/*  _________________________________________
    Reading peak values from an accelerometer
    _________________________________________
*/
 
// Hardware  
int ledPin = 13;
int xaccPin = 2;
int yaccPin = 3;
 
boolean xmoved = false;
boolean ymoved = false; 
 
// low-level
int count, value;
 
// Constants
//#define MOTION_THRESHOLD 100; // gives strange errors.
int MOTION_THRESHOLD = 100;
 
// Variables
int nx, ox;    // new and old x acceleration values
int ny, oy;  
 
 // method to update acceleration values
void readNewX() {
  nx = readAcc(xaccPin);
  //ny = readAcc(yaccPin);
}
 
// method to save old acceleration values
void saveOldX() {
  ox = nx;
  //oy = ny;
}
  
void readNewY() {
  //nx = readAcc(xaccPin);
  ny = readAcc(yaccPin);
}
 
// method to save old acceleration values
void saveOldY() {
  //ox = nx;
  oy = ny;
}  
  
// method to determine if motion above threshold is detected
boolean motionStartedX() {
  boolean hasStarted;
  readNewX();                        // read new acc. values      
  hasStarted = (nx - ox) > MOTION_THRESHOLD; // TODO: implement y axis
  saveOldX();                        // save old acc. values
  return hasStarted;
}

boolean motionStartedY() {
  boolean hasStarted;
  readNewY();                        // read new acc. values      
  hasStarted = (ny - oy) > MOTION_THRESHOLD; // TODO: implement y axis
  saveOldY();                        // save old acc. values
  return hasStarted;
}

void loop() {
  // wait until action detected
  xmoved = false;
  ymoved = false;
  
  while( xmoved == false && ymoved == false )
  {
        xmoved = motionStartedX();
        ymoved = motionStartedY();
  }
 
  // loop until acceleration has ceased
  while(nx > ox && ny > oy) {
    if(xmoved)
    {
      saveOldX();
      readNewX();
      printByte('X');
      printInteger(nx);
      //printNewline();
      printByte('\n');
    }
    if(ymoved)
    {
      saveOldY();
      readNewY();
      printByte('Y');
      printInteger(ny);
      //printNewline();
      printByte('\n');
    }            
    
    
    delay(50); // ONLY FOR DEBUG
  }
  
  if(xmoved)
  {
    printByte('X');
   printInteger(nx);
   printByte('\n');
   //printNewline();
  }
  if(ymoved)
  {
    printByte('Y');
   printInteger(ny);
   printByte('\n');
   //printNewline();
  }
  //printString("turned.");
  //printNewline();
  //delay(100); // ONLY FOR DEBUG
}
 
 
/* -------------------------------------------------
 Low-level stuff
 -------------------------------------------------
 */
 
void setup() {
  Serial.begin(19200); // Sets the baud rate to 19200
  pinMode(ledPin, OUTPUT);
  pinMode(xaccPin, INPUT);
  pinMode(yaccPin, INPUT);
  // initialize new and old acc. values
  readNewX();
  saveOldX();
  readNewY();
  saveOldY();
  Serial.println("hello");
}
 
// method to convert raw acc. value to acceleration
int operateAcceleration(int time1) {  
  return abs(8 * (time1 / 10 - 500));
}
 
// method to read value from accelerometer sensor
int readAcc(int axe) {
  count = 0;
  value = digitalRead(axe);
  while(value == HIGH) { // Loop until pin reads a low
    value = digitalRead(axe);
  }
  while(value == LOW) { // Loop until pin reads a high
    value = digitalRead(axe);
  }
  while(value == HIGH) { // Loop until pin reads a low and count
    value = digitalRead(axe);
    count = count + 1;
  }
  //determine the value
  return operateAcceleration(count * 18); // * 18 calculates the time in miliseconds
}
 


